Added 2nd try to rsync when the 1st attempt fails to cache the burn image properly.
[backups/.git] / scripts / burn-imgs.sh
index a2793fe48136326c89fe571fa6baf49071e7835e..a24df15591ce9656cc2321dddefd8d1cc2f71475 100755 (executable)
@@ -2,14 +2,17 @@
 
 export PATH=$(dirname $0):/bin:/usr/bin:/sbin
 
-cronstopstart="/etc/init.d/cron"
+# source the default configuration
 . config.sh
 
+# source the system specific configuration
+[ -f /etc/lsbackups.conf ] && . /etc/lsbackups.conf
+
 # If the noburn file is there then don't burn.
 [ -f "$noburnfile" ] && exit 0
 
-# Discover disk images by looking for .img.md5sum files in $imagedir
-imgmd5=$(ls $imagedir/*.img.md5sum 2>/dev/null | head -n 1)
+# Discover disk images by looking for .iso.md5sum files in $imagedir
+imgmd5=$(ls $imagedir/*.iso.md5sum 2>/dev/null | head -n 1)
 
 # If we didn't find an non-empty file then exit gracefully
 [ -z "$imgmd5" ] && exit 0
@@ -22,6 +25,20 @@ img=${imgmd5%.md5sum}
 
 touch $noburnfile
 
+# Now check to see if we need to cache the image to a local drive before burning the image
+if [[ $cacheburnimg == 1 && -d $cacheburnimgdir ]]; then
+  rsync -av --exclude '*.mnt' $img* $cacheburnimgdir >> $logfile 2>&1
+  if [ $? != 0 ]; then
+    sleep 60
+    rsync -av --exclude '*.mnt' $img* $cacheburnimgdir >> $logfile 2>&1
+    if [ $? != 0 ]; then
+      cat $logfile | mailx -s "backups: failed to cache $img to local dir $cacheburnimgdir !!!" $mailto
+      exit 1
+    fi
+  fi
+  img=$cacheburnimgdir/$(basename "$img")
+fi
+
 # A little paranoia.  Make sure the disk image file is there.
 [ -z "$img" ] && exit 1
 [ -s "$img" ] || exit 1
@@ -31,10 +48,12 @@ $cronstopstart stop
 renice -10 $$
 
 # Burn the image to a disk.
-cdrecord-wrapper.sh -dao dev=$sdev $img > $logfile 2>&1
+cdrecord-wrapper.sh $cdrecordopts dev=$sdev $img >> $logfile 2>&1
 
 if [ "0" != "$?" ]; then
   echo >&2 "cdrecord failed!"
+  $cronstopstart start
+  cat $logfile | grep -v -e '[\b\r]' | mailx -s "backups: failed to burn $img!!!" $mailto
   exit 1
 fi
 
@@ -42,19 +61,28 @@ fi
 renice 0 $$
 $cronstopstart start
 
+# I don't know if this *really* helps but give cdrecord a chance to clean up.
+sleep 60
+
 # Now verify the disk by running md5sum on the entire contents of the disk
 md5sum=$(tempfile)
-dd if=$dev bs=1M count=4440 2>>$logfile | md5sum | awk '{print$1}' > $md5sum
+dd if=$dev bs=1M count=$imagesizemb 2>>$logfile | md5sum | awk '{print$1}' > $md5sum
 
 # Check that the md5sums match
 if ! cmp $md5sum $img.md5sum; then
-  echo "Failed" | mailx -s "DVD md5sum doesn't match image file!!!" $mailto
+  echo "md5sum check FAILED" >> $logfile
+  echo "dd if=$dev bs=1M count=$imagesizemb 2>>$logfile | md5sum | awk '{print\$1}' > $md5sum" >> $logfile
+  e2label $dev >> $logfile 2>&1
+  cat $logfile | grep -v -e '[\b\r]' | mailx -s "DVD md5sum doesn't match image file!!!" $mailto
   exit 1
 fi
 
 # Record the date in the stat file to indicate that this burn was a success
 date >> $img.stat
 
+# Update the source file stat file if we burned a cached copy of the image
+[[ $cacheburnimg == 1 && -d $cacheburnimgdir ]] && date >> ${imgmd5%.md5sum}.stat
+
 { # Send e-mail
   echo "Image md5sum:"
   cat $img.md5sum
@@ -65,11 +93,18 @@ date >> $img.stat
   cat $img.stat
   echo
   cat $logfile
-} | mailx -s "DVD burned.  File as $(basename ${img%.*})" $mailto > $logfile 2>&1
+} | grep -v -e '[\b\r]' | mailx -s "DVD burned.  File as $(basename ${img%.*})" $mailto >> $logfile 2>&1
 
 # Two lines in the stat file indicate two successful burns.  Clean-up the image.
-if [ "$(wc -l $img.stat 2>/dev/null | awk '{print$1}')" == "2" ]; then
-  # Burned the image twice.  Removing it and associated files!
+if [ "$(wc -l $img.stat 2>/dev/null | awk '{print$1}')" == "$makeXcopies" ]; then
+  # Burned the image $makeXcopies number of times.  Removing it and associated files! 
+  if [[ $cacheburnimg == 1 && -d $cacheburnimgdir ]]; then
+    # Remove our cached copy of the image, its md5sum, and stat file
+    rm -f $img{,.md5sum,.stat}
+    # Now restore our $img variable to point back to the original source file
+    img=${imgmd5%.md5sum}
+  fi
   rm -f $img{,.md5sum,.stat}
   [ -d $img.mnt ] && rmdir $img.mnt
 fi
+